package cofh.thermal.expansion.block.entity.machine;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cofh.core.util.helpers.FluidHelper;
import cofh.lib.api.StorageGroup;
import cofh.lib.fluid.FluidStorageCoFH;
import cofh.lib.inventory.ItemStorageCoFH;
import cofh.thermal.core.config.ThermalCoreConfig;
import cofh.thermal.core.util.managers.machine.ChillerRecipeManager;
import cofh.thermal.expansion.init.TExpTileEntities;
import cofh.thermal.expansion.inventory.container.machine.MachineChillerContainer;
import cofh.thermal.lib.block.entity.MachineBlockEntity;
import cofh.thermal.lib.util.recipes.IMachineInventory;
import cofh.thermal.lib.util.recipes.IThermalInventory;
import cofh.thermal.lib.util.references.ThermalTags;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.fluids.FluidStack;

public class MachineChillerTile extends MachineBlockEntity {
  protected ItemStorageCoFH inputSlot;
  
  protected ItemStorageCoFH outputSlot;
  
  protected FluidStorageCoFH inputTank;
  
  public MachineChillerTile(BlockPos pos, BlockState state) {
    super((BlockEntityType)TExpTileEntities.MACHINE_CHILLER_TILE.get(), pos, state);
    this.inputSlot = new ItemStorageCoFH(item -> (item.m_41720_() instanceof cofh.thermal.core.item.SlotSealItem || (this.filter.valid(item) && ChillerRecipeManager.instance().validItem(item))));
    this.outputSlot = new ItemStorageCoFH();
    this.inputTank = new FluidStorageCoFH(8000, fluid -> (this.filter.valid(fluid) && ChillerRecipeManager.instance().validFluid(fluid)));
    this.inventory.addSlot(this.inputSlot, StorageGroup.INPUT);
    this.inventory.addSlot(this.outputSlot, StorageGroup.OUTPUT);
    this.inventory.addSlot(this.chargeSlot, StorageGroup.INTERNAL);
    this.tankInv.addTank(this.inputTank, StorageGroup.INPUT);
    addAugmentSlots(ThermalCoreConfig.machineAugments);
    initHandlers();
  }
  
  protected int getBaseProcessTick() {
    return ChillerRecipeManager.instance().getBasePower();
  }
  
  protected boolean cacheRecipe() {
    this.curRecipe = ChillerRecipeManager.instance().getRecipe((IThermalInventory)this);
    if (this.curRecipe != null) {
      this.itemInputCounts = this.curRecipe.getInputItemCounts((IMachineInventory)this);
      this.fluidInputCounts = this.curRecipe.getInputFluidCounts((IMachineInventory)this);
    } 
    return (this.curRecipe != null);
  }
  
  protected boolean cacheRenderFluid() {
    if (this.curRecipe == null)
      return false; 
    FluidStack prevFluid = this.renderFluid;
    this.renderFluid = new FluidStack(this.inputTank.getFluidStack(), 1000);
    return !FluidHelper.fluidsEqual(this.renderFluid, prevFluid);
  }
  
  protected void resolveInputs() {
    if (!this.itemInputCounts.isEmpty() && !this.inputSlot.getItemStack().m_204117_(ThermalTags.Items.MACHINE_CASTS))
      this.inputSlot.modify(-((Integer)this.itemInputCounts.get(0)).intValue()); 
    for (int i = 0; i < this.fluidInputCounts.size(); i++)
      ((FluidStorageCoFH)inputTanks().get(i)).modify(-((Integer)this.fluidInputCounts.get(i)).intValue()); 
  }
  
  @Nullable
  public AbstractContainerMenu m_7208_(int i, Inventory inventory, Player player) {
    return (AbstractContainerMenu)new MachineChillerContainer(i, this.f_58857_, this.f_58858_, inventory, player);
  }
}
